 __________________________________________________________________________________________

;                    Tool: Remouves the .src section from a SpAsm PE
 __________________________________________________________________________________________


; Callback Equates / Macros:

[Adressee ebp+8    Message ebp+12    wParam ebp+16    lParam ebp+20]

[CallBack | #1 | push ebp | mov ebp esp]

[Return | mov esp ebp | pop ebp | ret 16]

________________________________________________________________________________________

[WindowClass:
 style: 3  lpfnWndProc: MainWindowProc  cbClsExtra: 0  cbWndExtra: 0
 hInstance: 0  hIcon: 0  hCursor: 0  hbrBackground: 6
 lpszMenuName: 0  lpszClassName: WindowClassName]               ; Window Class Structure

[WindowHandle: 0   WindowClassName: B$ 'Anything' 0
                   WindowCaption: 'Detroy SpAsm PE source...' 0]             ; Data

[true 1    false 0    NULL 0]

[WM_DESTROY 2         WM_CHAR 0102         WM_COMMAND 0111    WM_QUIT 012
 WM_CREATE 1          WM_PAINT 0F          WM_KEYDOWN 0100    WM_KEYUP 0101
 WM_LBUTTONDOWN 0201  WM_LBUTTONUP 0202    WM_MOUSEMOVE 0200  WM_CLOSE 010
 MK_LBUTTON 1         WM_RBUTTONDOWN 0204  WM_RBUTTONUP 0205  WM_SIZE 5
 WM_HSCROLL 0114      WM_VSCROLL 0115      WM_SYSCOMMAND 0112 WM_NOTIFY 04E]


[CS_HREDRAW 02          CS_VREDRAW 1             IDI_WINLOGO 32517
 IDC_ARROW 32512        COLOR_BACKGROUND 1       WS_OVERLAPPED 0
 WS_CAPTION 0C00000     WS_SYSMENU 080000        WS_THICKFRAME 040000
 WS_MINIMIZEBOX 020000  WS_MAXIMIZEBOX 010000    WS_OVERLAPPEDWINDOW  0CF0000
 WS_VISIBLE 010000000   CW_USEDEFAULT 080000000  SW_SHOW 5]  ; Some basic equates

[IDI_APPLICATION 32512  DLGWINDOWEXTRA 30
 WS_EX_CLIENTEDGE 0200
 SW_SHOWNORMAL 1  SW_SHOWDEFAULT 10]


[FilterStrings: B$  'Executable Files', 0, '*.EXE', 0
                    'Dynamic Link Library', 0, '*.DLL', 0
                    'Object File', 0, '*.OCX', 0, 0]

[UserFileFilter: 0 #50] [FullChoosenFile: 0 #50] [ChoosenFile: 0 #20]


[OFN_FILEMUSTEXIST 01000  OFN_PATHMUSTEXIST 0800     OFN_LONGNAMES 0200000
 OFN_EXPLORER 080000      OFN_HIDEREADONLY 04]

[OPEN_EXISTING 3   OPEN_ALWAYS 4  GENERIC_READ 080000000  GENERIC_WRITE 040000000
 FILE_SHARE_READ 1  FILE_SHARE_WRITE 2  FILE_ATTRIBUTE_ARCHIVE 20  CREATE_NEW 1
 GMEM_MOVEABLE 2  GMEM_ZEROINIT 040]

[OFN_FLAGS OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_LONGNAMES+OFN_EXPLORER+OFN_HIDEREADONLY]


[OpenFileNameStructure:  len  hwndFileOwner: 0  OF_hInstance: 0  FilterStrings
                         userFileFilter  200  NULL  FullChoosenFile  200  ChoosenFile
                         80  NULL  OpenFileTitle  OFN_FLAGS
                         nFileOffsetinChoosenFile: W$ 0  nFileExtensioninChoosenFile: 0
                         DefaultExtension: D$ NULL
                         HookCustomData:  NULL  HookProcPtr: NULL  HookTemplateName: 0]

[OpenFileTitle:        '-=SpAsm PE File=-' 0]

__________________________________________________________________________________________

; These menu equates are given by the menu editor ([ClipBoard])

[M00_Menu  2000                  M00_File  2001                  M00_Open  2002
 M00_Exit  2003                  M00_Edit  2004                  M00_Destoy_Source  2005
 M00_Info  2006]
________________________________________________________________________________________

; Some basic macros:

; Next ones are as good as "hand made":

[push | push #1 | #+1]  [pop | pop #1 | #+1]  [mov | mov #1 #2 | #+2] ; multi intructions
[inc | inc #1 | #+1]    [dec | dec #1 | #+1]       ; ex: push eax, ebx, ecx

[IfVal | cmp #1 #3 | jn#2 M1> | #4>L | M1:]        ; if mono line
                                                   ; ex: if eax e 2, add eax 3
[api | push #L>2 | call #1]

[move | push #2 | pop #1 | #+2]                    ; (for mem to mem moves, for exemple)


[If | cmp #1 #3 | jn#2 I1>]                        ; If (short) multiline
[Else_if | jmp I9> | I1: | cmp #1 #3 | jn#2 I1>]   ; for small instructions blocks
[Else | Jmp I9> | I1:]
[End_if | I1: | I9:]

[.If | cmp #1 #3 | jn#2 J1>>]
[.Else_if | jmp J9>> | J1: | cmp #1 #3 | jn#2 J1>>]
[.Else | Jmp j9>> | J1:]
[.End_if | J1: | J9:]

[..If | cmp #1 #3 | jn#2 K1>>]                        ; for nesting inside ".If"
[..Else_if | jmp K9>> | K1: | cmp #1 #3 | jn#2 K1>>]
[..Else | Jmp K9>> | K1:]
[..End_if | K1: | K9:]

[...If | cmp #1 #3 | jn#2 Z1>>]                       ; for nesting inside "..If"
[...Else_if | jmp Z9>> | Z1: | cmp #1 #3 | jn#2 Z1>>]
[...Else | Jmp Z9>> | Z1:]
[...End_if | Z1: | Z9:]

[While | W0: | cmp #1 #3 | jn#2 W9>]
[End_While | jmp W0< | W9:]

[.While | X0: | cmp #1 #3 | jn#2 X9>>]
[.End_While | jmp X0<< | X9:]

___________________________________________________________________________________________


[FirstMessage: fAdressee: 0  fMessage: 0  fwParam: 0  flParam: 0 0 0 0 0 0 0]   ; Win message
[MenuHandle: 0]
;[WindowX: 50  WindowY: 50  WindowW:650  WindowH:450]


Main:

    api 'Kernel32.GetModuleHandleA' 0      | mov D$hInstance eax, D$OF_hInstance eax

    api 'Kernel32.GetModuleHandleA' 0      | mov D$hInstance eax

    api 'User32.LoadIconA'  D$hInstance  1 | mov D$hIcon eax

    api 'User32.LoadCursorA' 0  IDC_ARROW  | mov D$hCursor eax

    api 'User32.RegisterClassA'  WindowClass

    api 'User32.LoadMenuA' D$hInstance M00_Menu | mov D$MenuHandle eax

    api 'User32.CreateWindowExA' WS_EX_CLIENTEDGE WindowClassName WindowCaption,
                                 WS_OVERLAPPEDWINDOW+WS_VISIBLE,
                                 CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT  0,
                                 D$MenuHandle  D$hInstance  0
      mov D$WindowHandle eax, D$hwndFileOwner eax

    api 'User32.ShowWindow'  D$WindowHandle SW_SHOW
    api 'User32.UpdateWindow'  D$WindowHandle


L1: api 'User32.GetMessageA' FirstMessage 0 0 0 | cmp eax 0 | je L9>
        api 'User32.TranslateMessage'  FirstMessage
        api 'User32.DispatchMessageA'  FirstMessage
    jmp L1<

L9: api 'Kernel32.ExitProcess' D$Wparam


__________________________________________________________________________________________


CallBack MainWindowProc:

    pushad
      mov eax D$Message

      .If eax e WM_CLOSE
          api 'USER32.DestroyWindow' D$WindowHandle

      .Else_If eax e WM_DESTROY
          api 'User32.PostQuitMessage' 0

      .Else_If eax e WM_Command
          If D$Wparam e M00_Exit
              api 'User32.SendMessageA' D$WindowHandle WM_CLOSE 0 0

          Else_If  D$Wparam e M00_Open
              api 'Comdlg32.GetOpenFileNameA' OpenFileNameStructure
              IfVal eax e TRUE, call LoadFile

          Else_If  D$Wparam e M00_Info
              api 'USER32.MessageBoxA'  0  InfoString  InfoTitle  0

          Else_If  D$Wparam e M00_Destoy_Source
              IfVal D$FileHandle ne 0, call DestroySource

          Else
              jmp I_don_t_care

          End_If
      .Else
          jmp I_don_t_care

      .End_If

      popad | mov eax 0 | return


I_don_t_care:
    popad | api 'User32.DefWindowProcA' D$Adressee D$Message D$wParam D$lParam | return



[InfoString: "
   This Tool purpose is to retrieve the source
   '.src' section from a SpAsm produced PE.
   
   Beware of savings: There is no way back!
   ", 0

 InfoTitle: 'Application Base', 0]

_________________________________________________________________________________________

[NotPE: 'No Source in this PE', 0
 MessageTitle: 'argh!!!...', 0
 OKPE: 'OK, file ready for source destruction', 0]

[FileHandle: 0    FileSize: 0    FileMemory: 0    PeStart: 0    SizeReadWrite:0
 EndOfSectionSearch: 0    EndOfNakedPe:0    NakedPeLen: 0]

LoadFile:
    If D$FileHandle ne 0
        api 'KERNEL32.CloseHandle' D$FileHandle | mov D$FileHandle 0
    End_If

    api 'KERNEL32.CreateFileA' ChoosenFile,
                                   GENERIC_READ,             ; Opened for Read/write
                                              0,             ; Shared for
                                              0,             ; Security
                                  OPEN_EXISTING,             ; for an existing or new file
                                            080,             ; File attribute normal
                                              0              ; hTemplateFile
       mov D$FileHandle eax

    api 'KERNEL32.GetFileSize'  D$FileHandle NULL
      mov D$FileSize eax

    api 'KERNEL32.GlobalAlloc' GMEM_MOVEABLE+GMEM_ZEROINIT eax
       mov D$FileMemory eax

    api 'KERNEL32.GlobalLock' D$FileMemory
       mov D$PeStart eax

    api 'KERNEL32.ReadFile' D$FileHandle eax D$FileSize SizeReadWrite NULL

    api 'KERNEL32.CloseHandle' D$FileHandle

    mov eax D$PeStart | add eax 0178 | mov esi eax     ; +0178 > first section header
    add eax 400 | mov D$EndOfSectionSearch eax             ; +(10*40) bytes per section

L0: lodsd | cmp eax '.src' | je L1>
      add esi 36 | cmp esi D$EndOfSectionSearch | jb L0<
        api 'USER32.MessageBoxA'  0  NotPE  MessageTitle  0 | ret
L1: mov D$esi-4 '.del'
    lodsd | lodsd | lodsd | lodsd | lodsd         ; eax > based pointer to source

    mov D$NakedPeLen eax
    add  eax D$PeStart |  mov D$EndOfNakedPe eax

  ; If one wants to arase the DOS sentence (untested):
    ;mov edi D$PeStart | add edi 78
    ;mov eax 0, ecx 47 | rep stosb

    api 'USER32.MessageBoxA'  0  OKPE  MessageTitle  0
  ret


[Done: 'Done', 0]

[NumberOfBytes: 0]

DestroySource:

    mov D$NumberOfBytes 0

    api 'KERNEL32.CreateFileA' ChoosenFile,
                                  GENERIC_WRITE,             ; Opened for Read/write
                                              0,             ; Shared for
                                              0,             ; Security
                                              2,             ; for an existing or new file
                                            080,             ; File attribute normal
                                              0              ; hTemplateFile
    mov D$FileHandle eax

    api 'KERNEL32.WriteFile' D$FileHandle  D$PeStart  D$NakedPeLen,
                             NumberOfBytes  0

    api 'KERNEL32.CloseHandle' D$FileHandle | mov D$FileHandle 0

    api 'USER32.MessageBoxA'  0  Done  MessageTitle  0
  ret

















